# Exercice 1

# 1a. Oui. Lance un terminal en arrire-plan dans lequel COL vaudra 25, puis un autre terminal au premier plan avec la valeur par dfaut de COL (pas ncessairement 25)
# 1b. Oui. Liste tous fichiers du rpertoire courant (*), et galement ceux appels '{"' , '"}' , ' ' (espace). Le ';' final ne sert  rien.
# 1c. Non, manque un ';' aprs '/etc'
# 1d. Oui. Si var est dfinie, excute la commande qu'elle contient, sinon excute ls avec les options -l et -s. Dans les deux cas, relaie la sortie  wc, donc le rsultat affich est le nombre de lignes et mots produits par la commande.
# 1e. Non, car le 'F' dans Function fait que Function est vue comme une commande. Donc la paire de parenthses () est un sous-shell qui n'excute rien, or cela est illicite.
# 2a. Affiche "message" si /etc existe et est un rpertoire (option -d). Sinon, n'affiche rien. L'appel  wc n'a aucun effet sur le rsultat final.
# 2b. Affiche le nombre de fichiers contenus par le rpertoire pass en argument si c'est un rpertoire; ne fait rien dans le cas contraire.
# 2c. Affiche simplement "/usr/local/bin/*". L'toile n'est pas rsolue car entre "".
# 2d. Affiche les fichiers dans /etc qui se terminent par '~' par ordre alphabtique inverse.


# Exercice 2
#
# NOTE : l'exercice est trait en dtail dans le TP2. La solution propose 
# ici en est une version simplifie.

function grouper() {
    local derniere=""

    while { read ligne; test "$ligne"; }; do
	if test "$ligne" = "$derniere"; then
	    echo "$ligne"
	    while test "$ligne" = "$derniere"; do
		read ligne
	    done
	fi
	derniere="$ligne"
    done
}

function memenom() {
    find $1 | 
    {
	while { read ligne; test "$ligne"; }; do
	    if test -f "$ligne"; then
		echo ${ligne##*/}
	    fi
	done | sort | grouper
    }
}


# Exercice 3.
#
# 1) conversion IP -> decimal
#

function ip2dec() {
    local ip=".$1" s=0 p=1
    local droite gauche

    while [ "$ip" ]; do
	droite=${ip##*.}
	s=$((s+$p*$droite))
	ip="${ip%.*}"
	p=$((p*256))
    done

    echo $s
}


# 2) conversion decimal -> IP
#
function dec2ip () {
    local i=1 n="$1" s=""

    while [ $i -le 4 ]; do
	s=$((n % 256)).$s
	n=$((n / 256))
	i=$((i + 1))
    done

    echo ${s%?}
}


# 3) borne sup engendree par un masque
# Entree: $1 = masque en notation hexa 0x...
# Sortie: valeur de la borne sup en decimal sur stdout

function bsup () {
    local masque=`hex2dec $1` 
    local p=1 s=0 i=1

    while [ $i -le 32 ]; do
	if [ $((masque % 2)) -eq 0 ]; then  # bit significatif pour l'adresse IP
	    s=$((s+p))
	    p=$((2*p))
	fi
	masque=$((masque / 2))
	i=$((i+1))
    done

    echo $s
}


# 4) generation d'adresses par masque
#
#
function etaler () {
    local masque=`hex2dec $1`
    local n=$2 p=1 
    local s=0

    while [ $n -gt 0 ]; do

	while [ $((masque % 2)) -eq 1 ]; do  # recherche d'un '0' dans le masque
	    p=$((2 * p))
	    masque=$((masque / 2))
	done

	if [ $((n % 2)) -eq 1 ]; then
	    s=$((s+p))
	fi

	p=$((2 * p))
	masque=$((masque / 2))
	n=$((n / 2))
    done

    echo $s
}


# 5) ensemble des adresses IP generees par un masque
#
function ipbymask () {
    local sup=`bsup $1`
    local i=0

    while [ $i -le $sup ]; do
	dec2ip `etaler $1 $i`
	i=$((i+1))
    done
}
